#!/bin/sh
echo ""
echo "*** Ubuntu 8.04 LTS customized kit ***"
echo "***     version 0.2       ***"
echo "***      simosnet.com     ***"
echo "***   for EeePC 901-X     ***"
echo ""

cd /usr/src
rm -f onlines

if ! [ "$1" = "debian" ]; then
  LANDRIVER=`lsmod|grep atl1e`
  [ "$LANDRIVER" = "" ] && insmod `uname -r`/atl1e.ko
  sleep 5
  wget http://simosnet.com/debian/packages/eeepc/onlines
  if ! [ -f onlines ]; then
      echo "ネットワークに接続できません"
      echo "LANケーブルを接続してください"
      echo "ネットワークの接続を確認したらリトライしてください"
      exit
  fi 
  apt-get update
  apt-get install -y -f build-essential --force-yes
  cp removable_root_fix.fdi /etc/hal/fdi/policy
else
  LANDRIVER=`lsmod|grep atl1e`
  if [ "$LANDRIVER" = "" ]; then
    cd L1e_Lan
    make clean
    KBUILD_NOPEDANTIC=1 make
    if ! [ -f atl1e.ko ]; then
       echo "開発環境がありません"
       echo "処理を中止します"
       exit;
    fi
    insmod atl1e.ko
    echo "iface eth0 inet dhcp" >> /etc/network/interfaces
    cd ../
  fi  
  ifdown eth0
  ifup eth0
  wget http://simosnet.com/debian/packages/eeepc/onlines
  if ! [ -f onlines ]; then
      echo "ネットワークに接続できません"
      echo "LANケーブルを接続してください"
      echo "ネットワークの接続を確認したらリトライしてください"
      exit
  fi
  apt-get update
fi

echo "** Installing ACPI modules"
#apt-get install -y -f eeepc-acpi-source  --force-yes
#m-a a-b eeepc-acpi
#dpkg -i eeepc-acpi-modules-$(uname -r)_*.deb
cd eeepc-acpi
make clean
make
cp eeepc_acpi.ko /lib/modules/$(uname -r)/kernel/drivers/acpi
cp /etc/modules modules.tmp
chmod 777 modules.tmp
echo "eeepc-acpi" >> modules.tmp
chmod 644 modules.tmp
mv modules.tmp /etc/modules
if  [ "$1" = "debian" ];  then
  sed -e "s/exit 0/exit 0\nmodprobe eeepc-acpi/" /etc/rc.local > rc.local.tmp
  mv rc.local.tmp /etc/rc.local
  chmod 755 /etc/rc.local
  cd /etc/rc5.d
  ln -s ../init.d/rc.local S99rc.local
  cd /usr/src/eeepc-acpi
fi
#rm eeepc-acpi-modules-$(uname -r)_*.deb

echo "** Installing LAN"
#wget 'http://simosnet.com/debian/packages/eeepc/rt2860-driver.tgz'
#tar zxvf rt2860-driver.tgz
cd ../*RT2860_Linux_STA*
make clean
rm -f os/linux/*.o
rm -f os/linux/*.ko
make
cp os/linux/rt2860sta.ko /lib/modules/$(uname -r)/kernel/drivers/net/wireless
cd ../L1e_Lan
make clean
KBUILD_NOPEDANTIC=1 make
mkdir -p /lib/modules/$(uname -r)/kernel/drivers/net/atl1e
cp atl1e.ko /lib/modules/$(uname -r)/kernel/drivers/net/atl1e

if ! [ "$1" = "debian" ]; then
echo "*** install web camera ***"
cd ../linux-uvc
make clean
make
cp uvcvideo.ko /lib/modules/$(uname -r)/ubuntu/media/usbvideo
fi

depmod -a
cd ../

echo "** Installing OSD"
[ "$1" = "debian" ] && apt-get install -y -f mlocate acpi-support --force-yes
#wget http://eee-osd.googlecode.com/files/eee-osd_2.1-0eeeXubuntu1_i386.deb
dpkg -i eee-osd_2.1-0eeeXubuntu1_i386.deb
cp -p eee-wifi-on-off.sh /etc/acpi
#rm eee-osd*

if [ "$2" = "gnome" ]; then
echo "** Gnome settings"
echo "* Setting smaller font sizes"
gconftool-2 --set /apps/nautilus/preferences/desktop_font --type string "Sans 8"
gconftool-2 --set /desktop/gnome/interface/document_font_name --type string "Sans 8"
gconftool-2 --set /desktop/gnome/interface/font_name --type string "Sans 8"
gconftool-2 --set /apps/metacity/general/titlebar_font --type string "Sans Bold 8"
gconftool-2 --set /desktop/gnome/interface/monospace_font_name --type string "Monospace 9"
echo "* Smaller toolbars icons only"
gconftool-2 --set /desktop/gnome/interface/toolbar_style --type string "icons"
echo "* Disabling UI sounds"
gconftool-2 --set /desktop/gnome/sound/event_sounds --type bool 0
echo "* Fixing mute key"
gconftool-2 --set /desktop/gnome/sound/default_mixer_tracks --type list --list-type string "[PCM]"
echo "* Fullscreen with <Alt>-F11"
gconftool-2 --set /apps/metacity/window_keybindings/toggle_fullscreen --type string "<Alt>F11"
echo "* Setting suspend when closing lid, blank screen"
gconftool-2 --set /apps/gnome-power-manager/actions/sleep_type_battery --type string "suspend"
gconftool-2 --set /apps/gnome-power-manager/actions/sleep_type_ac --type string "suspend"
gconftool-2 --set /apps/gnome-power-manager/buttons/lid_battery --type string "suspend"
gconftool-2 --set /apps/gnome-power-manager/buttons/lid_ac --type string "blank"
gconftool-2 --set /apps/gnome-power-manager/timeout/sleep_computer_ac --type int 0
gconftool-2 --set /apps/gnome-power-manager/timeout/sleep_computer_battery --type int 300
gconftool-2 --set /apps/gnome-power-manager/timeout/sleep_display_ac --type int 300
gconftool-2 --set /apps/gnome-power-manager/timeout/sleep_display_battery --type int 60
echo "* Don't display battery warning"
gconftool-2 --set /apps/gnome-power-manager/notify/low_capacity --type bool 0
echo "* Unconstraining windows to the top of the screen"
gconftool-2 --type bool --set /apps/compiz/plugins/move/allscreens/options/constrain_y 0
echo "Gnome-settings done."
fi

echo "** Configuring Sound"
echo "#options snd-hda-intel model=3stack-dig" > snd-hda-intel.tmp
echo "options snd-hda-intel model=auto" >> snd-hda-intel.tmp
mv snd-hda-intel.tmp /etc/modprobe.d/snd-hda-intel

echo "** Fix shutdown problem"
cp /etc/default/halt halt.tmp
chmod 777 halt.tmp
echo "rmmod snd_hda_intel" >> halt.tmp
chmod 644 halt.tmp
mv halt.tmp /etc/default/halt

#echo "** Fine tune the system"
#cp /proc/sys/vm/dirty_writeback_centisecs ~/dirty_writeback_centisecs.tmp
#chmod 777 ~/dirty_writeback_centisecs.tmp
#echo "1500" > ~/dirty_writeback_centisecs.tmp
#chmod 644 ~/dirty_writeback_centisecs.tmp
#mv ~/dirty_writeback_centisecs.tmp /proc/sys/vm/dirty_writeback_centisecs
#cp /etc/fstab fstab.tmp
#chmod 777 fstab.tmp
#echo "tmpfs /var/tmp tmpfs defaults,noatime 0 0" >> fstab.tmp
#echo "tmpfs /tmp tmpfs defaults,noatime 0 0" >> fstab.tmp
#chmod 644 fstab.tmp
#mv fstab.tmp /etc/fstab

echo "** Enable CPU speed scabling"
if [ -x /etc/init.d/powernowd ]; then
  /etc/init.d/powernowd stop
  apt-get remove -y -f  powernowd --force-yes
fi
apt-get install -y -f cpufrequtils cpufreqd sysfsutils --force-yes
modprobe p4_clockmod
cp /etc/sysfs.conf sysfs.conf.tmp
chmod 777 sysfs.conf.tmp
echo "devices/system/cpu/cpu0/cpufreq/scaling_governor = ondemand" >> sysfs.conf.tmp
chmod 644 sysfs.conf.tmp
mv sysfs.conf.tmp /etc/sysfs.conf
cp /etc/modules modules.tmp
chmod 777 modules.tmp
echo "p4_clockmod" >> modules.tmp
echo "cpufreq_ondemand" >> modules.tmp
chmod 644 modules.tmp
mv modules.tmp /etc/modules
cp cpufreqd.conf /etc
if [ "$1" = "debian" ]; then
  cd /etc/rc5.d
  ln -s ../init.d/cpufreqd S99cpufreqd
  ln -s ../init.d/cpufrequtils S99cpufrequtils
  ln -s ../init.d/sysfsutils S99sysfsutils
#fi
#if [ "$1" = "debian" ]; then
  echo "alsa sound driver install"
  cd /usr/src/alsa-driver-1.0.17
  make clean
  ./configure
  make
  make install
  alsaconf
  apt-get -f -y install --force-yes
fi

echo ""
echo ""
echo "カスタマイズを完了しました"
echo "システムを再起動してください"
